]> arthur.barton.de Git - ax-zsh.git/blobdiff - bin/axzshctl
Add axzshctl subcommand "list-enabled"
[ax-zsh.git] / bin / axzshctl
index 9372a33d000f11f9aa719e77f8b84d33493ca6eb..8298743a5a13bce228e173dccc16f34fb30c7443 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/zsh
+#!/usr/bin/env zsh
 #
 # AX-ZSH: Alex' Modular ZSH Configuration
 # Copyright (c) 2015-2016 Alexander Barton <alex@barton.de>
@@ -12,10 +12,6 @@ for dir ("$HOME/lib" "$HOME/.ax" /usr/local /opt/ax /usr); do
 done
 if [[ -z "$ax_common_sourced" ]]; then
        function ax_msg {
-               case "$1" in
-                 "1"|"2") echo -n "! "; ;;
-                 *) echo -n "* "; ;;
-               esac
                shift
                echo "$@"
        }
@@ -25,17 +21,24 @@ unset dir ax_common ax_common_sourced
 function Usage {
        echo "Usage: $NAME <command> [...]"
        echo
+       echo "  enable"
+       echo "    Enable AX-ZSH altogether."
+       echo "  disable"
+       echo "    Disable AX-ZSH altogether."
+       echo
        echo "  enable-plugin <name|directory> [<name|directory> [...]]"
        echo "    Enable plugin(s)."
-       echo
        echo "  disable-plugin <name> [<name> [...]]"
        echo "    Disable plugin(s)."
+       echo "  list-enabled"
+       echo "    List enabled plugins."
        echo
        echo "  reset-plugins"
        echo "    Reset active plugins to the default set."
-       echo
        echo "  enable-default-plugins"
        echo "    Enable all default plugins."
+       echo "  check-plugins"
+       echo "    Detect plugins which are \"useful\" on this system."
        echo
        echo "  set-theme <name>|-"
        echo "    Set active theme to <name>, or to the default."
@@ -47,7 +50,32 @@ function Usage {
 }
 
 function NormalizedPluginName {
-       echo "$1" | sed -e 's|/|#|g'
+       if [[ "$1" =~ "^[[:alnum:]-]+/[[:alnum:]_-]+$" ]]; then
+               echo "${1:gs/\//#}"
+       elif [[ "$1" =~ "/" ]]; then
+               echo "${1:t}"
+       else
+               echo "$1"
+       fi
+}
+
+function EnableAXZSH {
+       for f (~/.zlogin ~/.zlogout ~/.zprofile ~/.zshrc); do
+               ln -sv "$AXZSH/ax.zsh" "$f" \
+                       || ax_msg 2 "Failed to create symbolic link for \"$f\"!"
+       done
+}
+
+function DisableAXZSH {
+       for f (~/.zlogin ~/.zlogout ~/.zprofile ~/.zshrc); do
+               if [ -h "$f" ]; then
+                       rm -v "$f" || ax_msg 2 "Failed to remove \"$f\"!"
+               elif [ -e "$f" ]; then
+                       ax_msg 2 "Error: Not removing \"$f\", it is not a symbolic link!"
+               else
+                       ax_msg 1 "Warning: \"$f\" already does not exist. Ok."
+               fi
+       done
 }
 
 function EnablePlugin {
@@ -59,7 +87,7 @@ function EnablePlugin {
                return 1
        fi
 
-       if [[ "$1" =~ "/" ]]; then
+       if [[ "$1" =~ "^[[:alnum:]-]+/[[:alnum:]_-]+$" ]]; then
                # GitHub plugin
                mkdir -p "$AXZSH/repos"
                if [[ ! -e "$AXZSH/repos/$plugin" ]]; then
@@ -106,14 +134,26 @@ function DisablePlugin {
        return $r
 }
 
+function ListEnabledPlugins {
+       for plugin ($AXZSH/active_plugins/*(N)); do
+               print ${plugin:t:s/#/\//}
+       done
+       return 0
+}
+
 function ResetPlugins {
        local dir="$AXZSH/active_plugins"
+       local r1=0, r2=0
 
        if [[ -e "$dir" ]]; then
                ax_msg - "Removing all symbolic links in $dir ..."
-               find "$dir" -type l -print -delete
+               find "$dir" -type l -print -delete; r1=$?
        fi
-       return $?
+
+       ax_msg - "Removing all external repositories in \"$AXZSH/repos\" ..."
+       rm -fr "$AXZSH/repos"; r2=$?
+
+       [[ $r1 == 0 && $r2 == 0 ]] && return 0 || return 1
 }
 
 function EnableDefaultPlugins {
@@ -178,7 +218,7 @@ function UpgradeForeignPlugins {
        fi
 
        for dir ($AXZSH/repos/*(N)); do
-               name=$(basename "$dir" | sed -e 's|#|/|g')
+               name=${dir:t:s/#/\//}
                if [ -d "$dir/.git" ]; then
                        ax_msg - "Upgrading \"$name\" [git] ..."
                        (
@@ -191,19 +231,91 @@ function UpgradeForeignPlugins {
        done
 }
 
+function CheckPlugins {
+       missing_plugins=()
+       invalid_plugins=()
+
+       ax_msg - "Checking plugins ..."
+       for dir ($AXZSH/plugins/*(N)); do
+               plugin=${dir:t}
+
+               # Test if plugin is already enabled
+               [[ -e "$AXZSH/active_plugins/$plugin" ]] \
+                       && enabled=" (enabled)" \
+                       || unset enabled
+
+               # Test plugin ...
+               printf " - \"%s\"%s ... " "$plugin" "$enabled"
+               new_plugin=""
+               for script ($AXZSH/plugins/$plugin/$plugin.{zshrc,zprofile}); do
+                       [[ -r "$script" ]] || continue
+                       zsh -i -c "AXZSH_PLUGIN_CHECK=1 source $script"; r=$?
+                       if [[ $r -eq 0 ]]; then
+                               new_plugin=$plugin
+                               break
+                       fi
+               done
+               if [[ -n "$new_plugin" ]]; then
+                       detected_plugins+=($new_plugin)
+                       [[ -n "$enabled" ]] || missing_plugins+=($new_plugin)
+                       ax_msg 0 "OK."
+               elif [[ $r -eq 91 ]]; then
+                       ax_msg 1 "ignored."
+               elif [[ $r -eq 92 ]]; then
+                       ax_msg 1 "optional."
+               else
+                       [[ -n "$enabled" ]] && invalid_plugins+=($plugin)
+                       ax_msg 2 "failed."
+               fi
+       done
+       echo
+
+       result=0
+       if [[ -n "$missing_plugins" ]]; then
+               ax_msg 1 "Run the following command to enable all missing plugins:"
+               echo "$AXZSH/bin/axzshctl enable-plugin" $missing_plugins
+               echo
+               result=1
+       else
+               ax_msg 0 "All detected plugins are already enabled."
+       fi
+
+       if [[ -n "$invalid_plugins" ]]; then
+               ax_msg 1 "Run the following command to disable all failed plugins:"
+               echo "$AXZSH/bin/axzshctl disable-plugin" $invalid_plugins
+               result=1
+       else
+               ax_msg 0 "No failed plugins are enabled."
+       fi
+
+       echo
+       return $result
+}
+
 NAME="$0:t"
 
 [[ $# -gt 0 ]] || Usage
 
-if [[ -z "$AXZSH" || ! -d "$AXZSH" ]]; then
-       ax_msg 2 "Oops, \"AXZSH\" is not set or invalid!"
-       exit 3
+if [[ -z "$AXZSH" || ! -r "$AXZSH/ax.zsh" ]]; then
+       [[ -r "$HOME/.axzsh/ax.zsh" ]] && AXZSH="$HOME/.axzsh"
+       if [[ ! -r "$AXZSH/ax.zsh" ]]; then
+               ax_msg 2 "Oops, \"AXZSH\" is not set or invalid and can't be autodetected!"
+               exit 3
+       fi
 fi
 
 cmd="$1"
 shift
 
 case "$cmd" in
+       "enable")
+               [[ $# -eq 0 ]] || Usage
+               EnableAXZSH
+               ;;
+       "disable")
+               [[ $# -eq 0 ]] || Usage
+               DisableAXZSH
+               ;;
        "enable-plugin")
                [[ $# -gt 0 ]] || Usage
                for plugin in "$@"; do
@@ -216,6 +328,10 @@ case "$cmd" in
                        DisablePlugin "$plugin"
                done
                ;;
+       "list-enabled")
+               [[ $# -eq 0 ]] || Usage
+               ListEnabledPlugins
+               ;;
        "reset-plugins")
                [[ $# -eq 0 ]] || Usage
                ResetPlugins
@@ -225,6 +341,10 @@ case "$cmd" in
                [[ $# -eq 0 ]] || Usage
                EnableDefaultPlugins
                ;;
+       "check-plugins")
+               [[ $# -eq 0 ]] || Usage
+               CheckPlugins
+               ;;
        "set-theme")
                [[ $# -eq 1 ]] || Usage
                SetTheme "$1"